package electrosphere.renderer.ui;

/**
 *
 * @author amaterasu
 */
public abstract class Widget {
    
    public int width = 1;
    public int height = 1;
    
    public int positionX = 0;
    public int positionY = 0;
    
    public int parentWidth = 1;
    public int parentHeight = 1;
    
    public boolean visible = false;
    
    public int getWidth() {
        return width;
    }

    public int getHeight() {
        return height;
    }

    public int getPositionX() {
        return positionX;
    }

    public int getPositionY() {
        return positionY;
    }

    public boolean getVisible() {
        return visible;
    }

    public void setWidth(int width) {
        this.width = width;
    }

    public void setHeight(int height) {
        this.height = height;
    }

    public void setPositionX(int positionX) {
        this.positionX = positionX;
    }

    public void setPositionY(int positionY) {
        this.positionY = positionY;
    }

    public void setVisible(boolean draw) {
        this.visible = draw;
    }
    
    public void setParentWidth(int width){
        parentWidth = width;
    }
    
    public void setParentHeight(int height){
        parentHeight = height;
    }
    
    public abstract void draw(int parentFramebufferPointer, int parentWidth, int parentHeight);
    
}
